/* C implementation for merge sort, originally implemented by Michael Juenger (Cologne). 
   Minor changes by Frauke Liers (Cologne) 08/2011*/

#include <stdio.h>
#include <malloc.h>

int merge_sort();
int merge();

#define minusinfinity -10000000;

int main()

{

  int i,j,n, inversions;
  int *A;

  scanf("%d",&n);
  A = (int *) malloc((n+1)*sizeof(int));
  for (i=1; i<=n; i++) {
    scanf("%d",&j);
    A[i] = j;
  }

  inversions = 0;
  inversions = merge_sort(A,1,n,inversions);

  for (i=1; i<=n; i++) printf("%8d",A[i]);
  printf("\n");

  free(A);
  return 0;
}

int merge_sort(int* A, int p, int r, int inversions)

{

  int q;

  /***/ int k;

  /***/ printf("merge_sort (");
  /***/ for (k=p; k<=r; k++) printf(" %d ",A[k]);
  /***/ printf(") [%d,%d]\n",p,r);

  if (p<r) {
    q = p + ((r-p)/2);
    inversions = merge_sort(A,p,q, inversions);
    inversions = merge_sort(A,q+1,r, inversions);
    inversions = merge(A,p,q,r, inversions);
  }

  printf("inversions: %d\n",inversions);
  return inversions;

}

int merge(int* A, int p, int q, int r, int inversions)

{
  int i,j,k,ai,aj,leftover;
  int *B;

  B = (int *) malloc((r-p+2)*sizeof(int));

  /***/ printf("merge (");
  /***/ for (k=p; k<=r; k++) printf(" %d ",A[k]);
  /***/ printf(") [%d,%d,%d]",p,q,r);


  i = p;       ai = A[i];
  j = q + 1;   aj = A[j];

  leftover = q - p + 1;
   
  printf("leftover %d\n", leftover);

  for (k=1; k<=r-p+1; k++) { // linke teilfolge
    if (ai>aj) {
      B[k] = ai; 
      i++;
      leftover--;			
    if (i<=q) ai = A[i]; else ai = minusinfinity;
    }
    else {
      B[k] = aj; 
      j++;
      inversions += leftover;
      if (j<=r) aj = A[j]; else aj = minusinfinity;
    }
  }
  for (k=p; k<=r; k++) A[k] = B[k-p+1];

  /***/ printf("  --->  (");
  /***/ for (k=p; k<=r; k++) printf(" %d ",A[k]);
  /***/ printf(")\n");

  free(B);
  /***/ printf("inversions in merge: %d\n", inversions);
  return inversions;

}
